#!python

import os, sys, re, glob, time
from qblib import util

def print_data_table(zipfiles):
	cnt = len(zipfiles)
	
	datalines = []
	(zfile, desc) = zipfiles[0]
	datalines.append('<tr rowspan="%s"><td><a href="./%s">%s</a> </td>' % (cnt, zfile, desc))
	datalines.append('	<tr><td>%s</td></tr>' % util.html_date())

	for (zfile, desc) in zipfiles[1:]:
		datalines.append('<tr><td><a href="./%s">%s</a> </td></tr>' % (zfile, desc))
	print "\n".join(datalines)

def create_html():
	files = glob.glob('*.zip')
	zipfiles = []
	for f in files:
		desc = f.replace('.zip', '')
		desc = re.sub('\d+\_', '', desc)
		zipfiles.append([f, desc])
	print_data_table(zipfiles)

if __name__ == '__main__':
	create_html()
