#!python

import os, sys, re, glob
"""
This script read gb file, convert to fasta format
option:
	trimstart: trim the sequence to start
	trimend:  trim the sequence to end
"""
class Location:
	def __init__(self, locstr):
		self.complement = ''
		if re.match('complement', locstr):
			self.complement = 1
			locstr = re.sub('^complement(', '', locstr).sub(')$', '', locstr)
		locs, = re.findall('\d+\.\.\d+')
		start, end = locs.split('..')
		self.start = int(start)
		self.end = int(end)


class Feature(object):
	def __init__(self, name, location, **kw):
		self.__dict__['name'] = name
		self.__dict__['location'] = location
		for k, v in kw.items():
			self.__dict__[k] = v

def gb2fasta(gbfile, startfeat, endfeat):
	lines = open(gbfile).readlines()
	id = seq = ''
	startfeature = 0
	startseq = 0
	features = []
	for l in lines:
		if re.match('LOCUS', l):
			m = re.match('LOCUS\s+\w\s+\d+', l)
			if m:
				id = l.split()[1]
			else:
				id = os.path.basename(gbfile)
			id = re.sub('\s+', '', id)
			continue

		if re.match('FEATURES', l[5:]):
			startfeature = 1
			name, loc = l[5:].strip().split()
			f = Feature(name=name, location=Location(loc))
			features.append(f)
			continue
		elif re.match('/', l[30:]):
			if startfeature:
				k,v = l[31:].strip().split('=') 
				setattr(features[-1], k, v)
			continue			
		elif re.match('ORIGIN', l):
			startfeature = 0
			startseq = 1
			continue
		if startseq:
			seq += re.sub('[\\\d\s]', '', l.strip())
	
	#id = seq = ''
	print l
	print id
	print len(seq)

def do_all():
	files = glob.glob('*.ape') + glob.glob('*.gb') + glob.glob('*.gbk')
	print files
	for f in files:
		print f
		gb2fasta(f)

if __name__ == '__main__':
	do_all()
