#!python



import string, re, glob, os



FIELDS=['queryid', 'subjectid', 'identity', 'alignment_length', \

			'mismatch', 'gap', 'qstart', 'qend', 'sstart', 'send', 'evalue', 'bit_score']

NUM_FIELDS=['identity', 'alignment_length', 'mismatch', 'gap', 'qstart', 'qend', 'sstart', 'send', 'evalue', 'bit_score']



class BlastHSP:

	# Fields: Query id, Subject id, % identity, alignment length, mismatches, gap openings, q. start, q. end, s. start, s. end, e-value, bit score

	# these are the fields in blast result

	def __init__(self, **kv):

		for k in  FIELDS:

			self.__dict__[k] = ''



		for k, v in kv.items():

			if k in NUM_FIELDS:

				v = eval(v)

			self.__dict__[k] = v



	def __setattr__(self, k, v):

		self.__dict__[k] = v



	def __getattr__(self, k):

		if self.__dict__.has_key(k):

			return self.__dict_[k]

		return ""



	def __str__(self):

		tmp= ["%s=%s" % (k, self.__dict__[k]) for k in FIELDS]

		return ", ".join(tmp)



	def set(self, line):

		# line is a blast result line from -m 9

		cols = [x.strip() for x in line.split('\t')]

		if len(cols) < 12:

			return

		#cols = [eval(x) for x in cols]

		self.__dict__.update(dict(zip(FIELDS, cols)))

		for k in NUM_FIELDS:

			self.__dict__[k] = eval(self.__dict__[k])



	def format(self):

		tmp= [str(self.__dict__[k]) for k in FIELDS]

		return "\t".join(tmp+[self.category])

