#!python


import os, tempfile, sys, pprint, re
import BlastParser

class Blast:
	def __init__(self, prog, infile, db, outfile='', option=''):
		self.prog = prog
		self.infile = os.path.abspath(infile)
		self.db = db
		self.outfile = os.path.abspath(outfile)
		self.option = option
	
		#self.parser = BlastParser.BlastParser()

	def do_blast(self):
		# run formatdb if need
		# check db
		blastdir = os.path.dirname(os.path.abspath(self.db))
		mydb = os.path.basename(self.db)
		curdir = os.path.abspath(os.path.curdir)

		if self.prog in ['blastn']:
			mydb += '.nin'
		elif self.prog in ['blastp']:
			mydb += '.pin'

		os.chdir(blastdir)
		# check for index file, run formatdb if there is no index file
		if not os.path.isfile(mydb):
			#print 'formatdb -i %s -p %s' % (self.db, dbtype)
			dbtype = 'F'
			os.system('formatdb -i %s -p %s' % (self.db, dbtype))
					
		#olddb = self.db
		#self.db = mydb
		cmd = 'blastall -p %(prog)s -i %(infile)s -d %(db)s -o %(outfile)s %(option)s' % self.__dict__
		#self.db=olddb
		print cmd
		os.system(cmd)

		os.chdir(curdir)
		
def find_match(myfasta, db, option = '', outfile='', matchcnt=0, match_len=300, tmp_dir='.', qlen=334):
	prog = 'blastn'
	if not outfile:
		outfile = myfasta + '.bls'

	#cwd = os.path.abspath(os.path.curdir)
	#print "CWD:", cwd
	#if not os.path.isdir(tmp_dir):
	#	os.mkdir(tmp_dir)

	#ifile = os.path.abspath(myfasta)
	#ofile = os.path.abspath(outfile)
	
	blast = Blast(prog = 'blastn', infile =myfasta, db = db, outfile = outfile, option=option)
	blast.do_blast()

	if not os.path.isfile(outfile) or os.path.getsize(outfile) == 0:
		print "INFO:: no blast result file"
		return {}	
	
	results = BlastParser.parse(outfile)
	print "RESULT COUNT:", len(results)

	query2ref = {}	
	for r in results:
		if r.hits:
			print r.query,  len(r.hits), matchcnt
                        keep = len(r.hits)
                        if matchcnt :
                                keep = matchcnt

			top_score = r.hits[0].bit_score
                        for h in r.hits[:keep]:
				if h.bit_score < top_score:
					break

			        print h.query, h.subj, h.length, h.ident, h.length
				'''
			        if h.length < match_len:
					print "... length=%s, skip=(%s,%s)" %  (h.length, r.query, r.sbj)
				        continue
				'''
				# 90% identity or 60% length?
				if h.ident < 90 and h.length < 0.6 * qlen:
					continue

                                query2ref.setdefault(r.query, [])
			        query2ref[r.query].append( h.subj )

	return query2ref

if __name__ == '__main__':

	b = Blast('blastn', 'x.fas', 'x.out')	

	b.do_blast()
	

