#!python
#=================================================================================================
# simple program interface for MySQLdb 
#=================================================================================================

import MySQLdb, os, sys,re, time

class MySql:
	def __init__(self):
		self.querylogging = 0

	def connect(self, host="localhost", username="internal", password="w00kie", database="test"):
		self.db = MySQLdb.connect(host, username, password, database)
		self.cur = self.db.cursor()
		#self.cur.setPrefetch(1000)
		return self

	def close(self):
		if self.db:
			self.cur.close()
			self.cur = None
			self.db.close()

	def begin_transaction(self):
		self.execute("savepoint QBSR")

	def end_transaction(self):
		self.execute("commit")

	def savepoint(self, label="generic"):
		self.execute('savepoint %s' % label)

	def commit(self):
		self.execute("commit")

	def rollback(self, label=""):
		if not label:
			self.execute("rollback")
		else:
			self.execute("rollback to savapoint %s" % label)

	def query(self, querystring, posparams=None, max_results=None):
		qs = querystring.strip()
		if qs.endswith(';'):
			qs = qs[:-1]

		if posparams :
			self.cur.execute(qs, posparams)
		else:
			self.cur.execute(qs)

		if max_results:
			return self.cur.fetchmanay(max_results)
		else:
			return self.cur.fetchall()

	def execute(self, querystring, posparams=None):
		qs = querystring.strip()
		if qs.endswith(';'):
			qs = qs[:-1]

		if posparams :
			return self.cur.execute(qs, posparams)
		else:
			return self.cur.execute(qs)

	def execute_many(self, querystring, posparams):
		qs = querystring.strip()
		if qs.endswith(';'):
			qs = qs[:-1]

		return self.cur.executemany(qs, posparams)

def connect(host='localhost', username='internal', password='w00kie', database='test'):
	db = MySql()
	db.connect(host, username, password, database)
	return db
