#!/usr/bin/python

#from qblib import MySql
import os, re, glob, sys

"""
CHECK'		QBID	NAME	SEQUENCE					
		??	ACYCDuetUP1(71178)	GGATCTCGACGCTCTCCCT	58.52641203				
1		QB0001	3AOX1	GCAAATGGCATTCTGACATCC		3AOX		Operon	BOX1
1		QB0002	5AOX1	GACTGGTCCAATTGACAAGC		5AOX		Operon	BOX1
1		QB0003	AC5	ACACAAAGCCGCTCCATCAG				Operon	BOX1
1		QB0004	Alpha-factor	TACTATTGCCAGCATTGCTGC				Operon	BOX1
"""
qbidx = 2
def load(qbprimer):
	if not os.path.isfile(qbprimer):
		print "ERROR: Primer file (%s) is not valid " % qbprimer
		sys.exit()	

	lines = open(qbprimer).readlines()
	P = open('primer.txt', 'w')
	QB = open('qbprimer.txt', 'w')

	id = get_last_id('primer')
	name2qb = {}
	headers = []

	for l in lines:
		if l.find('QBID') != -1:
			headers = [x.strip() for x in l.split('\t')]
			continue

		if not re.search('QB\d+', l, re.IGNORECASE):
			continue
		cols = [x.strip() for x in l.split('\t')]	
		d = dict(zip(headers, cols))
		qbid = d['QBID']
		name = d['NAME']
		sequence = d['SEQUENCE']
		sequence = re.sub('\s*', '', sequence).upper()
		if not qbid:
			print "SKIP: no qbid --%s--" % l.strip()
			continue
		_qbid = re.sub('QB', '', qbid, re.IGNORECASE)
		name = name.strip()
		if not name:
			print "SKIP: no name ->%s<-" % l.strip()
			continue
		if not _qbid:
			print "WARNING: not qbid for name: %s"  % name
		if len(name) > 30:
			print "WARNING: name -%s- is too long, truncate to 30 chararter ", name
			name = name[:30]
		elif not name:
			print "WARNING: invalid name -%s-" % name

		_qbid = int(_qbid)

		name2qb.setdefault(name, []).append((_qbid, sequence))

	primers = []
	qbprimers = []
	for name, qbseqs in name2qb.items():
		qbseqs.sort(lambda x,y: cmp(x[0], y[0]))
		id = qbseqs[0][0]
		primers.append([id, name])
		for x in qbseqs:
			qbid, seq = x
			qbprimers.append((qbid, id, seq))

	primers.sort(lambda x,y: cmp(x[0], y[0]))
	qbprimers.sort(lambda x,y: cmp(x[0], y[0]))
	for p in primers:
		id, name = p
		print >> P, "%s\t%s" % (id, name)

	for p in qbprimers:
		qbid, id, seq = p
		print >>QB, "%s\t%s\t%s" % (qbid, id, seq)
	P.close()
	QB.close()


def get_last_id(tablename):
	id = 1
	return id;

if __name__ == '__main__':
	load(sys.argv[1])
	
