#!python

import sys, os, re, glob, pprint

from config import *
import ABISeq, Clone, Fasta

def get_clones(datadirs, outdir=''):
	return get_allclones('_', datadirs, outdir)

def get_allclones(sep, datadirs,outdir='',score=40, length=300):
	print "GET ALL CLONES from ", datadirs
	"""
	sep: delimtor used to seperated template and primer: <template>seq<primer>
	"""
	cloned = {}
	# make sure each directory is processed once
	d = dict([(x,1) for x in datadirs])
	datadirs = d.keys()
	print "datadirs:", datadirs

	allseqs = get_allseqs(datadirs, score=score, length=length)

	for s in allseqs:
		template, primer = s.get_template_primer(sep=sep)
		#print 'pro..', template, primer, s.sample
		if not template:
			print "  tempalte=%s, primer=%s" %(template, primer), s.file
		cloned.setdefault(template, []).append(s)

	cd = {}
	for clone, seqs in cloned.items():
		c = Clone.Clone(name=clone, reads = seqs)
		cd[clone] = c
	
	return cd


def get_allseqs(dirlist,trim=0, score=20, length=300):
	allseqs = []
	for d in dirlist:
		print "processing directory: %s" % d
		abifiles = glob.glob(os.path.join(d, '*.ab1'))
		for f in abifiles:
			#if re.match('N?_', f):
			#	print "skiping %s" % f
			#	continue
			s = ABISeq.ABISeq(f, seqlen=length) 
			if trim:
				s.trim_by_quality()
				#if not s.trimscore or s.trimscore < score  :
				#	print ".. skip LOW QUALITY sequence: %s, score=%s" % (s.sample	, s.trimscore)
				#	continue
			allseqs.append(s )
			#print f
	return allseqs

