#!python

import time, re, os, string, getopt, sys

def today():
	x  = time.localtime()
	y,m,d, hr, min = x[:5]
	y2 = y-2000
	#print "YEAE: %s" % y
	return "%02d%02d%02d" % (m, d, y2)

def format_well(well):
	# format well so it is in the form of [A-H]\d\d, e.g. A02, A12
	num = re.findall('\d+$', well)
	if num:
		num, = num
		#row = re.sub('%s$' % num, '', well)
		m = re.match('[A-H]',well, re.IGNORECASE)
		
		if m:
			row = well[:1]
			well = '%s%02d' % (row.upper(), int(num))
	return well	

def rename(datadirs, format='name-well_primer'):
	"""
	reserved words: name, well, primer, name is required, well and primer are optional
	separator: any
	"""
	if not name_m:
		print "ERROR: file name format error, has to have 'name' in the format"
		sys.exit()
	
	if type(datadirs) == type(''):
		datadirs = [datadirs]

	datepat = re.compile('\d{4}\-\d{2}\-\d{2}')
	wellpat = re.compile('[A-Ha-h]\d\d?')
	cappat  = re.compile('\d{3}')

	# raw data file format name-well_primer.ab1
	for d in datadirs:
		if not os.path.isdir(d):
			pass
		# rename all files in d
		print ">>> renaming files in %s" % d
		for (root, dirs, files) in os.walk(d):
			for f in files:
				ext = os.path.splitext(f)[-1]
				# default file name format: <AT1G02720.1>_<M13F>_<2009-07-05>_<D12>_<090>.<ab1>
				# name_[primer_]date_well_cap.ab1, primer is optional
				# get date, well, cap first
				datem = datepat.search(	f )
				if datem:
					datestr = f[datem.start():]
					well = datestr.split('_')[1]

					sample = f.replace('_%s' % datestr, '') 
					_idx = sample.rfind('_')
					primer = sample[_idx+1:]
					template = sample[:_idx]

					#f2 = '%s-%s_%s%s' % (template, well, primer, ext)
					f2 = format.replace('name', template)
					f2 = f2.replace('well', well)
					f2 = f2.replace('primer', primer)
					f2 = '%s%' % (f2, ext)
					#print f, datestr, sample, template, primer , f2
					try:
						os.rename(os.path.join(root, f), os.path.join(root, f2))
					except:
						print "ERROR: renaming %s to f2" % (f, f2) 
						continue

def parse_args(args, optstr, usage):
	try:
		opts, ars = getopt.getopt(args, optstr)
	except:
		print usage
		sys.exit()


	optd = {}
	for (o, v) in opts:
		o = re.sub('^\-\-?', '', o) 
		optd.setdefault(o, v)

	return (optd, ars)


def parse_config(file):
	d = {}
	datad = {}
	lines = open(file).readlines()

	keys = []
	for l in lines:
		if re.match('#', l):
			continue

		l = l.strip()
		if l == '':
			continue

		if re.match('\[', l, re.IGNORECASE):
			key = re.sub('^\[', '', l)
			key = re.sub('\]$', '', key)
			#print "KEY:", key
			for k in d.keys():
				d[k] = 0
			d.setdefault(key, 1)
			#print d
			continue
	
		for k,v in d.items():
			if v:
				datad.setdefault(k, []).append(l)
	return datad

ZIP = "o:\\tools\\bin\\windows\\zip.exe"
def zip(d):
	# create a zip for everything within directory d
	print '%s -mrq %s.zip %s' % (ZIP, d, d) 
	os.system('%s -mrq %s.zip %s' % (ZIP, d, d) )

def log_cmd(cmd):
		# log command line
	if type(cmd) == type([]):
		cmd = " ".join(cmd)

	Log = open("log_%s.txt" % os.path.basename(os.path.abspath(os.path.curdir)), 'w')
	print >>Log, cmd
	Log.close()
