#!python

import os, sys, re, glob
from qblib import ABISeq, util

def remove_bad(score=40, length=200):
	print "remove sequence with score < %s, and length < %s" % (score, length)
	# create a BAD directory within cwd
	#move anything with score<40 or length < 500 to BAD
	dname = 'BAD'
	if not os.path.isdir(dname):
		os.mkdir(dname)

	for n in os.listdir(os.path.curdir):
		if not os.path.isfile(n):
			continue
		if not n.endswith('ab1'):
			continue
		base = os.path.splitext(n)[0]

		s = ABISeq.ABISeq(n)
		s.trim_by_quality()
		if s.trimscore < score or s.trimlength() < length:
			print 'move %s to BAD' % n, s.trimscore, s.trimlength()
			try:
				os.system('mv %s* BAD' % base)
			except:
				continue


def do_remove_bad(args):
	usage = """
	%s -s score -l length
	-s: 20 default
	-l: 500 default
	""" % __file__

	optd, ars = util.parse_args(args, "s:l:", usage)
	print optd, ars
	score = 40
	length = 200
	if optd.has_key('s'):
		score = int(optd['s'])
	if optd.has_key('l'):	
		length = int(optd['l'])

	remove_bad(score, length)

if __name__ == '__main__':
	#remove_bad()
	do_remove_bad(sys.argv[1:])
