#!python

import os, re, glob, time, sys


HEADERS = ['check', 'qbid', 'name', 'sequence' ]
def process(file):
	print "... processing file:" , file

	d = {}

	lines = open(file).readlines()


	# do we have a header line 
	header = ''
	for l in lines:
		if re.search('qbid', l, re.I):
			header = l
		break

	headers = []
	if header:
		headers = re.split('[,\t]', header)
		headers = [s.strip() for s in headers]
	else:
		headers = HEADERS

	headers = [x.lower() for x in headers]
	lineN = 0
	for l in lines[1:]:

		lineN += 1
		if not l.strip():

			print "skipping 0:", cols
			continue

		cols = re.split('[,\t]', l)
		cols = [x.strip() for x in cols]
		if len(cols) < 4:
			print "skipping 1:", cols
			continue

		d2 = dict(zip(headers, cols))

		#print cols
		try:
			qbid = d2['qbid']
			name = d2['name']
			sequence = d2['sequence']
		except:
			print cols
			sys.exit()

		if not qbid and not name:
			print 'skipping 2:', qbid, name, sequence
			continue
		#qbid = eval(qbid)
		#name = eval(name)
		name = re.sub('[\'\"#\s]', '', name)
		sequence = sequence.strip()
		sequence = re.sub("^[AGTCagtc]", '', sequence)

		if not sequence:

			print 'skipping 2:', cols
			continue


		#print lineN, qbid, name, sequence
		d.setdefault(sequence,[]).append('%s:%s' % (qbid, name))
	out = "QBprimers.fas"

	files = glob.glob('*'+out)

	c = len(files) + 1

	if os.path.isfile(out):

		os.rename(out, '%s_%s' % (c, out))

	outf = open(out, 'w')



	for seq, names in d.items():

		print>>outf, '>'+";".join(names)

		print >>outf, seq

	outf.close()



	print "TOTAL primers count:", len(d.keys())

	os.system('formatdb -i %s -p F' % out)



if __name__ == '__main__':

	if len(sys.argv) < 2:
		print "Usage: %s primer.txt" % sys.argv[0]
		sys.exit()

	process(sys.argv[1])

