#!python

import os, sys, re, glob
from qblib import util

# called by cp3730data.py

SUFFIX = re.compile('\_((BO)|A|J|T|V|(MJ)|(Pu)|(BE))$')
ZIP = "O:\\tools\\bin\\windows\\zip.exe"
scp = "O:\\tools\\bin\\windows\\pscp.exe"
keyfile = "O:\\tools\\keys\\ssh2_rsa.ppk"
ssh = "O:\\tools\\bin\\windows\\plink.exe"
datastore = "/home/quintara/datastore/Quintara_data"

def upload_data(datastr, platename='', optd={}):
	tmpdir = 'C:\\temp'
	tmpzip = 'test.zip'
	zipfile = '%s\\%s' % (tmpdir, tmpzip)
	if not os.path.isdir(tmpdir):
		os.mkdir(tmpdir)

	# create tmp zip file
	cmd = "%s -rq %s %s" % (ZIP, zipfile, datastr)
	print cmd
	os.system(cmd)
	
	# upload zip file to godaddy
	cmd = "%s -i %s %s  quintara@184.168.107.141:/home/quintara/datastore/Quintara_data/%s" % (scp, keyfile, zipfile, tmpzip)
	print cmd
	os.system(cmd)

	# remove local zip file
	cmd = "rm -rf %s" % zipfile
	os.system(cmd)

	# unzip and load on godaddy
	# pass option
	options = []
	for k, v in optd.items():
			options.append('-%s' % k)
			if v:
				options.append(v)
	optstr = " ".join(options)
	cmd ="""%s -i %s -l quintara 184.168.107.141 /home/quintara/bin/extract_data.sh %s %s """ % (ssh, keyfile, optstr, platename)
	print cmd
	os.system(cmd)

def is_sample_sheet(file):
	plateid = ''
	lines = open(file).readlines()
	line = lines[0]
	col1 = line.split('\t')[0]
	if col1 == 'Container Name':
		line = lines[1]
		plateid = line.split('\t')[1]
	return plateid

def do_upload(ars, optd):
	ssd={}
	datad={} 
	for a in ars:
		if os.path.isfile(a):
			plateid = is_sample_sheet(a)
			if plateid:
				ssd[plateid] = a
				continue

		elif os.path.isdir(a):
			pid = re.sub('^20\d\d\-\d\d\-\d\d\_', '', a)
			pid = SUFFIX.sub('', pid)
			datad[pid] = a
			continue

		# neith a valid file or data directory, do pattern matching
		files = glob.glob('%s*.txt' % a)
		for f in files:
			plateid = is_sample_sheet(f)
			if plateid:
				ssd[plateid] = f

	# combine platedata and sample sheet
	for plateid, datadir in datad.items():
		mydata = [datadir]
		if ssd.has_key(plateid):
			mydata.append(ssd[plateid])
			mydata = " ".join([str(x) for x in mydata])
			upload_data(datastr=mydata, optd=optd)	
			del ssd[plateid]
		
	# upload the rest sample sheets
	if ssd:
		sheets = ssd.values()
		upload_data(datastr = " ".join(sheets), optd=optd)


def test():
	upload_data('011612A.txt', '2012-01-16_011612A_A')

def do(args):
	# get options
	usage= """ 
	Usage: upload_goddy.py [option] <samplesheet.txt> [datadir]
	valid command: 
		support option: 
			-R reload data: reload database, copy file to user order directory
			-Q load score:  populate db with score only

		upload_goddy.py 011712A.txt # this will load 011712A.txt
		upload_goddy.py 011712A.txt 2012-01-18_011712A_A
		upload_goddy.py 011712A # this will load sample sheet 011712A*.txt 
		upload_goddy.py 011712  # this will load sample sheet 011712*.txt
		if <ss> does not end with .txt, pattern matching will be used
		""" 

	optd, ars = util.parse_args(args, "R:Q", usage)

	do_upload(ars=ars, optd=optd)

if __name__ == '__main__':
	do(sys.argv)

